{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Hist.TAxis.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType
import HROOT.Core.TArrayD.RawType

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_SetName"
               c_taxis_setname :: Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetNameTitle" c_taxis_setnametitle ::
               Ptr RawTAxis -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTitle" c_taxis_settitle ::
               Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetNdivisions" c_taxis_getndivisions ::
               Ptr RawTAxis -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetAxisColor" c_taxis_getaxiscolor ::
               Ptr RawTAxis -> IO CShort

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetLabelColor" c_taxis_getlabelcolor ::
               Ptr RawTAxis -> IO CShort

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetLabelFont" c_taxis_getlabelfont ::
               Ptr RawTAxis -> IO CShort

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetLabelOffset" c_taxis_getlabeloffset ::
               Ptr RawTAxis -> IO CFloat

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetLabelSize" c_taxis_getlabelsize ::
               Ptr RawTAxis -> IO CFloat

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetTitleOffset" c_taxis_gettitleoffset ::
               Ptr RawTAxis -> IO CFloat

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetTitleSize" c_taxis_gettitlesize ::
               Ptr RawTAxis -> IO CFloat

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetTickLength" c_taxis_getticklength ::
               Ptr RawTAxis -> IO CFloat

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetTitleFont" c_taxis_gettitlefont ::
               Ptr RawTAxis -> IO CShort

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetNdivisions" c_taxis_setndivisions ::
               Ptr RawTAxis -> CInt -> CBool -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetAxisColor" c_taxis_setaxiscolor ::
               Ptr RawTAxis -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetLabelColor" c_taxis_setlabelcolor ::
               Ptr RawTAxis -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetLabelFont" c_taxis_setlabelfont ::
               Ptr RawTAxis -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetLabelOffset" c_taxis_setlabeloffset ::
               Ptr RawTAxis -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetLabelSize" c_taxis_setlabelsize ::
               Ptr RawTAxis -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTickLength" c_taxis_setticklength ::
               Ptr RawTAxis -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTitleOffset" c_taxis_settitleoffset ::
               Ptr RawTAxis -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTitleSize" c_taxis_settitlesize ::
               Ptr RawTAxis -> CFloat -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTitleColor" c_taxis_settitlecolor ::
               Ptr RawTAxis -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTitleFont" c_taxis_settitlefont ::
               Ptr RawTAxis -> CShort -> IO ()

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_Clear"
               c_taxis_clear :: Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_Draw"
               c_taxis_draw :: Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_FindObject" c_taxis_findobject ::
               Ptr RawTAxis -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_GetName"
               c_taxis_getname :: Ptr RawTAxis -> IO CString

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_IsA"
               c_taxis_isa :: Ptr RawTAxis -> IO (Ptr RawTClass)

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_Paint"
               c_taxis_paint :: Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_printObj" c_taxis_printobj ::
               Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_SaveAs"
               c_taxis_saveas :: Ptr RawTAxis -> CString -> CString -> IO ()

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_Write"
               c_taxis_write :: Ptr RawTAxis -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_Write_"
               c_taxis_write_ :: Ptr RawTAxis -> IO CInt

foreign import ccall interruptible "HROOTHistTAxis.h TAxis_delete"
               c_taxis_delete :: Ptr RawTAxis -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_newTAxis" c_taxis_newtaxis ::
               CInt -> CDouble -> CDouble -> IO (Ptr RawTAxis)

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_findBinTAxis" c_taxis_findbintaxis ::
               Ptr RawTAxis -> CDouble -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_findFixBinTAxis" c_taxis_findfixbintaxis ::
               Ptr RawTAxis -> CDouble -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_getBinCenterTAxis"
               c_taxis_getbincentertaxis :: Ptr RawTAxis -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetBinCenterLog" c_taxis_getbincenterlog ::
               Ptr RawTAxis -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_GetBinUpEdge" c_taxis_getbinupedge ::
               Ptr RawTAxis -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetCenterLabels"
               c_taxis_taxis_getcenterlabels :: Ptr RawTAxis -> IO CBool

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetCenterTitle"
               c_taxis_taxis_getcentertitle :: Ptr RawTAxis -> IO CBool

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetFirst" c_taxis_taxis_getfirst ::
               Ptr RawTAxis -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetLast" c_taxis_taxis_getlast ::
               Ptr RawTAxis -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetNbins" c_taxis_taxis_getnbins ::
               Ptr RawTAxis -> IO CInt

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetXbins" c_taxis_taxis_getxbins ::
               Ptr RawTAxis -> IO (Ptr RawTArrayD)

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetXmax" c_taxis_taxis_getxmax ::
               Ptr RawTAxis -> IO CDouble

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_tAxis_GetXmin" c_taxis_taxis_getxmin ::
               Ptr RawTAxis -> IO CDouble

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetLimits" c_taxis_setlimits ::
               Ptr RawTAxis -> CDouble -> CDouble -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTimeDisplay" c_taxis_settimedisplay ::
               Ptr RawTAxis -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTimeFormat" c_taxis_settimeformat ::
               Ptr RawTAxis -> CString -> IO ()

foreign import ccall interruptible
               "HROOTHistTAxis.h TAxis_SetTimeOffset" c_taxis_settimeoffset ::
               Ptr RawTAxis -> CDouble -> CString -> IO ()
